# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Spiffy
Version:	0.46
Release:	27.%{__distinit}%{__distvers}
Summary:	Framework for doing object oriented (OO) programming in Perl
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/Spiffy
Source0:	https://cpan.metacpan.org/authors/id/I/IN/INGY/Spiffy-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.30
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Data::Dumper)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(Filter::Util::Call)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
BuildRequires:	perl(YAML)
# Test Suite
BuildRequires:	perl(base)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::More)
# Release Tests
BuildRequires:	perl(Test::Pod) >= 1.41
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Data::Dumper)
Requires:	perl(Filter::Util::Call)
Requires:	perl(overload)
Requires:	perl(Scalar::Util)
Requires:	perl(warnings)
Requires:	perl(YAML)

# Filter bogus provide of perl(DB)
%global __provides_exclude ^perl\\(DB\\)

%description
"Spiffy" is a framework and methodology for doing object oriented (OO)
programming in Perl. Spiffy combines the best parts of Exporter.pm,
base.pm, mixin.pm and SUPER.pm into one magic foundation class. It attempts
to fix all the nits and warts of traditional Perl OO, in a clean,
straightforward and (perhaps someday) standard way.

%prep
%setup -q -n Spiffy-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test RELEASE_TESTING=1

%files
%license LICENSE
%doc Changes CONTRIBUTING README
%{perl_vendorlib}/Spiffy.pm
%doc %{perl_vendorlib}/Spiffy.pod
%{perl_vendorlib}/Spiffy/
%{_mandir}/man3/Spiffy.3*

%changelog
* Thu May  4 2023 Paul Howarth <paul@city-fan.org> - 0.46-27
- Use SPDX-format license tag
- Drop support for building with rpm < 4.9
- Use %%license unconditionally

* Tue Jun  4 2019 Paul Howarth <paul@city-fan.org> - 0.46-14
- Perl 5.30 rebuild

* Fri Apr 13 2018 Paul Howarth <paul@city-fan.org> - 0.46-10
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Mon Sep 26 2016 Paul Howarth <paul@city-fan.org> - 0.46-6
- BR: perl-generators where available
- Simplify find command using -delete
- Prefer %%global over %%define

* Tue Sep  9 2014 Paul Howarth <paul@city-fan.org> - 0.46-1
- Update to 0.46
  - Meta 0.0.2
  - Eliminate spurious trailing whitespace
  - Eliminate File::Basename from test/
  - Add t/000-compile-modules.t

* Thu Aug 28 2014 Paul Howarth <paul@city-fan.org> - 0.42-2
- Perl 5.20 rebuild

* Sat Aug  9 2014 Paul Howarth <paul@city-fan.org> - 0.42-1
- Update to 0.42
  - Only support back to 5.8.1

* Thu Aug  7 2014 Paul Howarth <paul@city-fan.org> - 0.41-1
- Update to 0.41
  - Remove (c) from Copyright
  - Add badges to docs
  - Fix a bug that was causing lots of warnings in Test::Base on perl 5.21
  - Fix bad encoding in Pod

* Thu Jul 31 2014 Paul Howarth <paul@city-fan.org> - 0.37-1
- Update to 0.37
  - Update IRC in Meta

* Mon Jul 28 2014 Paul Howarth <paul@city-fan.org> - 0.36-1
- Update to 0.36
  - Fix email in Meta

* Tue Jul 22 2014 Paul Howarth <paul@city-fan.org> - 0.35-1
- Update to 0.35
  - Fix Meta and add Contributing
- Use %%license where possible

* Thu Jun 19 2014 Paul Howarth <paul@city-fan.org> - 0.34-1
- Update to 0.34
  - Metadata fixes

* Wed Jun 18 2014 Paul Howarth <paul@city-fan.org> - 0.32-1
- Update to 0.32
  - Release with Zilla::Dist
- Classify buildreqs by usage
- Package upstream's LICENSE file
- Drop %%defattr, redundant since rpm 4.4

* Thu Aug  2 2012 Paul Howarth <paul@city-fan.org> - 0.31-1
- Update to 0.31
  - Bring Makefile.PL up to date
  - Make tests not use the 'B' package (CPAN RT#72542)
  - Use Module::Package

* Tue Jun 12 2012 Paul Howarth <paul@city-fan.org> - 0.30-19
- BR: perl(Data::Dumper) and perl(Exporter)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Mon Sep 26 2011 Paul Howarth <paul@city-fan.org> - 0.30-18
- Import from Fedora

* Fri Jun 17 2011 Marcela Mašláňová <mmaslano@redhat.com> - 0.30-17
- Perl mass rebuild

* Tue Apr 19 2011 Paul Howarth <paul@city-fan.org> - 0.30-16
- Make the provides filter work with rpm 4.9 too

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.30-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Wed Dec 22 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.30-14
- Rebuild to fix problems with vendorarch/lib (#661697)

* Thu May 06 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.30-13
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.30-12
- Rebuild against perl 5.10.1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.30-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.30-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Feb 02 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0.30-9
- Rebuild for new perl

* Wed Jan 02 2008 Ralf Corsépius <rc040203@freenet.de> - 0.30-8
- Adjust License tag
- BR: perl(Test::More) (BZ 419631)

* Wed Apr 18 2007 Steven Pritchard <steve@kspei.com> - 0.30-7
- Use fixperms macro instead of our own chmod incantation
- BR ExtUtils::MakeMaker

* Mon Sep 04 2006 Steven Pritchard <steve@kspei.com> - 0.30-6
- Rework spec to look more like current cpanspec output

* Tue Feb 28 2006 Steven Pritchard <steve@kspei.com> - 0.30-5
- Improve filter

* Mon Feb 27 2006 Steven Pritchard <steve@kspei.com> - 0.30-4
- Drop dummy mixin.pm

* Mon Feb 27 2006 Steven Pritchard <steve@kspei.com> - 0.30-3
- Filter out Provides: perl(DB)

* Mon Feb 27 2006 Steven Pritchard <steve@kspei.com> - 0.30-2
- Drop explicit Provides: mixin
- Add dummy mixin.pm
- Improve Summary
- Fix Source0

* Sat Feb 25 2006 Steven Pritchard <steve@kspei.com> - 0.30-1
- Update to 0.30
- Drop explicit perl BR

* Wed Dec 28 2005 Steven Pritchard <steve@kspei.com> - 0.24-1
- Specfile autogenerated
